#!/usr/bin/php
<?php

//ライブラリ読み込み
require_once("Net/POP3.php");
require_once("Mail.php");
require_once("Mail/mime.php");

//設定読み込み
require_once dirname(__FILE__)."/recbymail.config.php";
if(DEBUGSW=="on"){
	echo("DEBUGSW = on\n");
	echo("System Encoding = mb_internal_encoding()\n");
	define("SMTP_DEBUG", true);
} else{
	define("SMTP_DEBUG", false);
}
$client = null;
function getRpc(){
	global $client;
	if($client == null){
		if(RPC_TYPE == 2){
			require_once dirname(__FILE__)."/xmlrpc.class.php";
			$client = new XmlRpc();
		} else {
			require_once dirname(__FILE__)."/httprpc.class.php";
			$client = new HttpRpc();
		}
	}
	return $client;
}


//POP3サーバーに接続
$pop = new Net_POP3();
$pop->connect(POP_HOST, POP_PORT);
$pop->login(POP_USER, POP_PSWD, "USER");

//メール受信＆リクエスト処理 ===============================
$messages = $pop->getListing();
if($messages){
        foreach($messages as $k => $row){
		$return=null;
		$request=null;
                $id = $row["msg_id"];
                $status = $pop->getMsg($id);
		preg_match("/Return-Path:.*<(.+)>.*/",$status,$matches);
		$return=$matches[1];
		preg_match("/Subject:(.+)/",$status,$matches);
		$request=mb_decode_mimeHeader(trim($matches[1]));
		if(DEBUGSW=="on"){
			echo("--- receivemail ---\n");
			echo($return."\n");
			echo($request."\n");
			echo("-------------------\n");
		}
		//リクエスト処理へ
		if( $return!=null and $request!=null ){
			proc_request($return,$request);
		}
        }
}
//メインループここまで ====================================
$pop->disconnect();
exit();


//リクエスト処理関数
function proc_request($return,$request){

	$msg="";
	$write=false;
	$file=null;

	//情報返信(HTMLファイル添付)
	if(preg_match("/^番組表HTML$/i", $request)){
		if(DEBUGSW=="on"){ print("番組表HTMLと認識\n"); };
		$file=dirname(__FILE__)."/bangumihyou.html";
		file_put_contents($file,file_get_contents(EPGREC_URL."index.php"));
		$msg="番組表のHTMLを添付したよ。　by 録るメーラー";
	}
	elseif(preg_match("/^番組情報HTML$/i", $request)){
		if(DEBUGSW=="on"){ print("番組情報HTMLと認識\n"); };
		$file=dirname(__FILE__)."/bangumi.html";
		file_put_contents($file,file_get_contents(EPGREC_URL."programTable.php"));
		$msg="番組一覧のHTMLを添付したよ。　by 録るメーラー";
	}
	elseif(preg_match("/^予約情報HTML$/i", $request)){
		if(DEBUGSW=="on"){ print("予約情報HTMLと認識\n"); };
		$file=dirname(__FILE__)."/yoyaku.html";
		file_put_contents($file,file_get_contents(EPGREC_URL."reservationTable.php"));
		$msg="予約一覧のHTMLを添付したよ。　by 録るメーラー";
	}
	elseif(preg_match("/^録画情報HTML$/i", $request)){
		if(DEBUGSW=="on"){ print("録画情報HTMLと認識\n"); };
		$file=dirname(__FILE__)."/rokugazumi.html";
		file_put_contents($file,file_get_contents(EPGREC_URL."recordedTable.php"));
		$msg="録画番組一覧のHTMLを添付したよ。　by 録るメーラー";
	}

	//情報返信(TEXT)
	elseif(preg_match("/^番組情報(TEXT)?$/i", $request)){
		if(DEBUGSW=="on"){ print("番組情報TEXTと認識\n"); };
		$files = fopen(EPGREC_URL."programTable.php", "r");
		$count=0;
		while( ($line = fgetss($files, 1024 )) !== false) {
			$line=trim($line);
			if($write){
				$msg=$msg.$line."\n";
				if(preg_match("/^表示最大(.+)まで$/",$line)){
					$write=false;
				}
			}
			elseif($msg==""){
				if($line==null){
					$count++;
				}
				else{
					if($count==3){
						$msg="番組の情報だよ。　by 録るメーラー\n\n\n\n".$line."\n";
						$write=true;
					}
					$count=0;
				}
			}
		}
		fclose($files);
	}
	elseif(preg_match("/^予約情報(TEXT)?$/i", $request)){
		if(DEBUGSW=="on"){ print("予約情報TEXTと認識\n"); };
		$files = fopen(EPGREC_URL."reservationTable.php", "r");
		$count=0;
		while( ($line = fgetss($files, 1024 )) !== false) {
			$line=trim($line);
			if($write){
				if(preg_match("/^jQuery UI Dialog$/",$line)){
					$write=false;
				}
				else{
					$msg=$msg.$line."\n";
				}
			}
			elseif($msg==""){
				if($line==null){
					$count++;
				}
				else{
					if($count==3){
						$msg="予約の情報だよ。　by 録るメーラー\n\n\n\n".$line."\n";
						$write=true;
					}
					$count=0;
				}
			}
		}
		fclose($files);
	}
	elseif(preg_match("/^録画情報(TEXT)?$/i", $request)){
		if(DEBUGSW=="on"){ print("録画情報TEXTと認識\n"); };
		$files = fopen(EPGREC_URL."recordedTable.php", "r");
		$count=0;
		while( ($line = fgetss($files, 1024 )) !== false) {
			$line=trim($line);
			if($write){
				if(preg_match("/^jQuery UI Dialog$/",$line)){
					$write=false;
				}
				else{
					$msg=$msg.$line."\n";
				}
			}
			elseif($msg==""){
				if($line==null){
					$count++;
				}
				else{
					if($count==3){
						$msg="録画済みの情報だよ。　by 録るメーラー\n\n\n".$line."\n";
						$write=true;
					}
					$count=0;
				}
			}
		}
		fclose($files);
	}

	//録画予約
	elseif(preg_match("/^(TV|TV録画|録画)?予約\s?(GR|BS|CS)?((.+)ch)?\s?((\d{1,2})時)?\s?(.+)$/", $request, $matches)){
		$type   =$matches[2];
		$channel=$matches[4];
		$hour   =$matches[6];
		$title  =$matches[7];
		$rpc = getRpc();
		$results = $rpc->searchProgram($title, $type, $channel, $hour);
	
		if(count($results) == 0){
			$msg="指示された番組が見つからないよ。　by 録るメーラー";
		} elseif(count($results) > 1){
			$msg="番組が絞りきれないぞい、もっと詳しく指示してちょ。　by 録るメーラー";
		} else {
			$result = $results[0];
			try{
				$rpc->reserveProgram($result["program_id"]);	
				$msg="予約できたよ。　by 録るメーラー\r\n".$result["title"];
			} catch (Exception $e) {
				if(DEBUGSW=="on"){ print_r($e); };
				$msg=$e->getMessage()."　by 録るメーラー";
				$msg=$msg."\r\n".$result["title"];
			}
		}
	}

	//録画解約
	elseif(preg_match("/^(TV|TV録画|録画)?解約\s?(GR|BS|CS)?((.+)ch)?\s?((\d{1,2})時)?\s?(.+)$/", $request, $matches)){
		$type   =$matches[2];
		$channel=$matches[4];
		$hour   =$matches[6];
		$title  =$matches[7];
		$rpc = getRpc();
		$results = $rpc->searchProgram($title, $type, $channel, $hour);
		if(count($results) == 0){
			$msg="指示された番組が見つからないよ。　by 録るメーラー";
		} elseif(count($results) > 1){
			$msg="番組が絞りきれないぞい、もっと詳しく指示してちょ。　by 録るメーラー";
		} else {
			$result = $results[0];
			try{
				$rpc->cancelreserveProgram($result["program_id"]);	
				$msg="解約できたよ。　by 録るメーラー\r\n".$result["title"];
			} catch (Exception $e) {
				if(DEBUGSW=="on"){ print_r($e); };
				$msg=$e->getMessage()."　by 録るメーラー";
				$msg=$msg."\r\n".$result["title"];
			}
		}
	}

	//ヘルプ(recbymailの使い方)
	elseif(preg_match("/^HELP$/i", $request)||preg_match("/^使い方$/", $request)||preg_match("/^使用方法$/", $request)||preg_match("/^ヘルプ$/", $request)||preg_match("/^教えて$/", $request)||preg_match("/^助けて$/", $request)){
		$msg=file_get_contents(dirname(__FILE__)."/recbymail.help.txt");
	}

	//構文エラー
	else{
		$msg="コマンド構文エラーだよ。　by 録るメーラー";
	}

	if($msg!=""){
		mailsend($return,"Re:".$request,$msg,$file);
		if($file){ unlink($file); };
	}

}


//メール送信関数
function mailsend($to,$subject,$body,$attachfile){
	if(DEBUGSW=="on"){
		echo("--- mailsend ---\n");
		echo("TO     : ".$to."\n");
		echo("Subject: ".$subject."\n");
		echo("Body   : ".$body."\n");
		echo("Attach : ".$attachfile."\n");
		echo("----------------\n\n");
	}
	//日本語のエンコード
	$body = mb_convert_encoding($body,"iso-2022-jp");
	$subject=mb_encode_mimeheader(mb_convert_encoding($subject,"iso-2022-jp"));
	//SMTP接続
	$params = array(
	    "host"     => SMTP_HOST,
	    "port"     => SMTP_PORT,
	    "auth"     => true,
	    "username" => SMTP_USER,
	    "password" => SMTP_PSWD,
	    "debug"    => SMTP_DEBUG,
	);
	$smtp = Mail::factory("smtp", $params);
	//添付ファイル処理
	$mime = new Mail_Mime("\n");
	$mime->setTxtBody($body);
	$mime->addAttachment($attachfile,"application/octet-stream");
	$body_encode = array(
	    "head_charset" => "ISO-2022-JP",
	    "text_charset" => "ISO-2022-JP"
	);
	$body = $mime->get($body_encode);
	//ヘッダー生成
	$headers = array(
	    "To"      => $to,
	    "From"    => SMTP_FROM,
	    "Subject" => $subject,
	);
	$header = $mime->headers($headers);
	//送信実行
	$ret = $smtp->send($to, $header, $body);
	if ( PEAR::isError($ret) ) {
		echo("メール送信エラー：".$ret->getMessage()."\n");
	}
}

?>
